/*:
 * @target MZ
 * @author Aerosys
 * @plugindesc [Tier 1] [Version 1.0.0] [MV & MZ]
 * 
 * @help
 * 
 * ----------------------------------------------------------------------------
 * Rules
 * ----------------------------------------------------------------------------
 * 1. This Plugin is free of charge and can be used in any kind of game.
 * 2. You may not redistribute this Plugin or claim it as your own.
 * 3. You may modify this plugin's source code for your needs but cannot
 *    redistribute your modifications.
 * 
 * 
 * NEED SUPPORT?
 * Contact me: mail<at>aerosys.blog
 * 
 * @endofhelp
 * 
 * 
 * @param booleanSettings
 * @text Boolean Settings
 *
 * @param alwaysDash
 * @parent booleanSettings
 * @text Always Dash
 * @type boolean
 * @default true
 * 
 * @param commandRemember
 * @parent booleanSettings
 * @text Command Remember
 * @type boolean
 * @default false
 * 
 * @param touchUI
 * @parent booleanSettings
 * @text Touch UI
 * @type select
 * @option on
 * @option when on mobile
 * @option off
 * @default when on mobile
 * @desc Only enabled when on MZ
 * 
 * @param volumeSettings
 * @text Volume Settings
 * 
 * @param bgmVolume
 * @parent volumeSettings
 * @text BGM
 * @type number
 * @default 10
 * 
 * @param bgsVolume
 * @parent volumeSettings
 * @text BGS
 * @type number
 * @default 10
 * 
 * @param meVolume
 * @parent volumeSettings
 * @text ME
 * @type number
 * @default 10
 * 
 * @param seVolume
 * @parent volumeSettings
 * @text SE
 * @type number
 * @default 10
 * 
 * @param volumeOffset
 * @parent volumeSettings
 * @text Offset
 * @type number
 * @default 5
 * @desc Offset in the Options Menu
 * 
 */

var params = PluginManager.parameters('MK_DefaultOptionValues');

// Override
AudioManager._bgmVolume = Number(params.bgmVolume || 0);
AudioManager._bgsVolume = Number(params.bgsVolume || 0);
AudioManager._meVolume  = Number(params.meVolume || 0);
AudioManager._seVolume  = Number(params.seVolume || 0);

// Override
ConfigManager.alwaysDash      = 'true' == params.alwaysDash;
ConfigManager.commandRemember = 'true' == params.commandRemember;

ConfigManager.touchUI = (
  ('MZ' == Utils.RPGMAKER_NAME)
  &&
  (
    'on' == params.touchUI ||
    ('when on mobile' == params.touchUI && Utils.isMobileDevice())
  )
);


// Override
Window_Options.volumeOffset = Number(params.volumeOffset || 1);
Window_Options.prototype.volumeOffset = function() {
  return Window_Options.volumeOffset;
};
