/*:
 * @target MZ
 * @plugindesc [Tier 1] [Version 2.2.4] (please read the License Part 2)
 * @author Aerosys
 * @url https://aerosys.blog
 * @
 * 
 * @help
 * This is the Base Plugin for MK_RNGMaps.
 * 
 * LICENSE & UNLOCKING FULL VERSION
 * 
 * - RNGMaps provides a free trial. The free trial offers all Map Generation
 *   Algorithms, but with limited functionality (e.g. no seedable RNG).
 * - There are no "2 different" plugins for free and full version, it doesn't
 *   matter whether you copied them from the free or paywalled download.
 * - Instead, the plugins check if MK_RNGMaps_Addons is included in the Game
 *   on start up.
 *   If so, the plugins run in "full version" mode, otherwise in "trial mode".
 * - The trial version only works in the maker's test play. When using it in an
 *   exported game, it will abort its launch.
 * 
 * 
 * UNLOCKING FULL VERSION
 * 
 * To unlock the Free Version, please copy-paste MK_RNGMaps_Addons into your
 * Game and enable it in the Plugin Manager.
 * 
 * 
 * RULES
 * 
 * 1. You are not allowed to re-distribute my plugins
 * 2. One exception: Due to the nature of JavaScript, it's okay when you
 *    release your game.
 * 3. When several people work on the same project, it's not required to
 *    purchase a license for everyone.
 *    But that does not mean, that anyone gets a copy for free for their
 *    own needs.
 * 4. You are allowed to modify readable source code for your own needs, but
 *    you are not allowed to re-distribute your changes (e.g. as a plugin).
 * 5. You are not allowed to de-obfuscate obfuscated code.
 * 
 * @endofhelp
 * 
 * 
 * =====================================================================================
 * PARAMS
 * =====================================================================================
 * 
 * @param regionIds
 * @text Region Ids
 * @type struct<RegionIds>
 * @default {"North":"","northernExit":"13","northernMainExit":"37","northernSpawnLocation":"14","West":"","westernExit":"8","westernMainExit":"32","westernSpawnLocation":"9","East":"","easternExit":"15","easternMainExit":"39","easternSpawnLocation":"16","South":"","southernExit":"5","southernMainExit":"29","southernSpawnLocation":"6","decorationStopperId":"61"}
 * 
 * @param shadows
 * @text Shadows (global)
 * @type struct<Shadows>
 * @desc These settings may be overriden by individual settings in a template
 * @default {"horizontal":"2","vertical1":"3","vertical2":"1"}
 * 
 * @param --------------------------
 * @default --------------------------
 * 
 * @param advanced
 * @text Advanced
 * 
 * @param maxRetries
 * @parent advanced
 * @text max Retries if failed
 * @type number
 * @desc The plugins uses trial-and-error until all important assets spawn properly
 * @default 50
 */

/*~struct~RegionIds:
 * 
 * @param North
 *
 * @param northernExit
 * @parent North
 * @text Exit
 * @type number
 * @default 13
 * 
 * @param northernMainExit
 * @parent North
 * @text Main Exit
 * @type number
 * @default 37
 * 
 * @param northernSpawnLocation
 * @parent North
 * @text Spawn Location
 * @type number
 * @default 14
 * 
 * @param West
 *
 * @param westernExit
 * @parent West
 * @text Exit
 * @type number
 * @default 8
 * 
 * @param westernMainExit
 * @parent West
 * @text Main Exit
 * @type number
 * @default 32
 * 
 * @param westernSpawnLocation
 * @parent West
 * @text Spawn Location
 * @type number
 * @default 9
 * 
 * @param East
 * 
 * @param easternExit
 * @parent East
 * @text Exit
 * @type number
 * @default 15
 * 
 * @param easternMainExit
 * @parent East
 * @text Main Exit
 * @type number
 * @default 39
 * 
 * @param easternSpawnLocation
 * @parent East
 * @text Spawn Location
 * @type number
 * @default 16
 * 
 * @param South
 * 
 * @param southernExit
 * @parent South
 * @text Exit
 * @type number
 * @default 5
 * 
 * @param southernMainExit
 * @parent South
 * @text Main Exit
 * @type number
 * @default 29
 * 
 * @param southernSpawnLocation
 * @parent South
 * @text Spawn Location
 * @type number
 * @default 6
 * 
 *
 * @param decorationStopperId
 * @text Decoration Stopper Id
 * @type number
 * @desc Region Id to determine the last object in your decoration map
 * @default 61
 * 
 */

/*~struct~Shadows:
 *
 * @param active
 * @text draw Shadows?
 * @type boolean
 * @default false
 * 
 * @param when
 * @text when draw Shadows:
 * 
 * @param horizontal
 * @parent when
 * @type select
 * @option 0
 * @option 1
 * @option 2
 * @option 3
 * @option 4
 * @option 5
 * @default 2
 * 
 * @param vertical1
 * @parent when
 * @text vertical (top)
 * @type select
 * @option 0
 * @option 1
 * @option 2
 * @option 3
 * @option 4
 * @option 5
 * @default 3
 * 
 * @param vertical2
 * @parent when
 * @text vertical (floor)
 * @type select
 * @option 0
 * @option 1
 * @option 2
 * @option 3
 * @option 4
 * @option 5
 * @default 1
 * 
 */

'use strict';


var MK=MK||{};MK['alias']=MK['alias']||{};var Imported=Imported||{};Imported['MK_RNGMaps_Core']=!![];if(!Imported['MK_Core'])alert('Missing\x20Plugin:\x20MK_Core');var params=PluginManager['parameters']('MK_RNGMaps_Core');function fail(_0x3008bb='Some\x20Parameter'){throw Error(_0x3008bb+'\x20in\x20MK_RNGMaps_Core\x20is\x20not\x20set.\x20Please\x20set\x20it\x20in\x20the\x20Plugin\x20Manager');}if(!params['regionIds'])fail('Region\x20Ids');if(!params['shadows'])fail('Shadows');MK['EXIT_NORTH']=Number(JSON['parse'](params['regionIds'])['northernExit']),MK['MAIN_EXIT_NORTH']=Number(JSON['parse'](params['regionIds'])['northernMainExit']),MK['SPAWN_NORTH']=Number(JSON['parse'](params['regionIds'])['northernSpawnLocation']),MK['EXIT_WEST']=Number(JSON['parse'](params['regionIds'])['westernExit']),MK['MAIN_EXIT_WEST']=Number(JSON['parse'](params['regionIds'])['westernMainExit']),MK['SPAWN_WEST']=Number(JSON['parse'](params['regionIds'])['westernSpawnLocation']),MK['EXIT_EAST']=Number(JSON['parse'](params['regionIds'])['easternExit']),MK['MAIN_EXIT_EAST']=Number(JSON['parse'](params['regionIds'])['easternMainExit']),MK['SPAWN_EAST']=Number(JSON['parse'](params['regionIds'])['easternSpawnLocation']),MK['EXIT_SOUTH']=Number(JSON['parse'](params['regionIds'])['southernExit']),MK['MAIN_EXIT_SOUTH']=Number(JSON['parse'](params['regionIds'])['southernMainExit']),MK['SPAWN_SOUTH']=Number(JSON['parse'](params['regionIds'])['southernSpawnLocation']),MK['DECORATION_STOPPER_ID']=Number(JSON['parse'](params['regionIds'])['decorationStopperId']),MK['ACCESSIBLE_REGION_ID']=Number(JSON['parse'](params['regionIds'])['accessibleId']),MK['MAX_RETRIES']=Number(params['maxRetries']);const shadowSettings=JSON['parse'](params['shadows']);MK['shadows']=JSON['parse'](params['shadows']),MK['shadows']['horizontal']='true'==shadowSettings['active']?Number(MK['shadows']['horizontal']):0x0,MK['shadows']['vertical1']='true'==shadowSettings['active']?Number(MK['shadows']['vertical1']):0x0,MK['shadows']['vertical2']='true'==shadowSettings['active']?Number(MK['shadows']['vertical2']):0x0;if(isNaN(MK['EXIT_NORTH']))fail();if(isNaN(MK['MAIN_EXIT_NORTH']))fail();if(isNaN(MK['SPAWN_NORTH']))fail();if(isNaN(MK['EXIT_WEST']))fail();if(isNaN(MK['MAIN_EXIT_WEST']))fail();if(isNaN(MK['SPAWN_WEST']))fail();if(isNaN(MK['EXIT_EAST']))fail();if(isNaN(MK['MAIN_EXIT_EAST']))fail();if(isNaN(MK['SPAWN_EAST']))fail();if(isNaN(MK['EXIT_SOUTH']))fail();if(isNaN(MK['MAIN_EXIT_SOUTH']))fail();if(isNaN(MK['SPAWN_SOUTH']))fail();if(isNaN(MK['DECORATION_STOPPER_ID']))fail();if(isNaN(MK['MAX_RETRIES']))fail('Max\x20Retries');(function(){function _0x7e1b83(){return Imported['MK_RNGMaps_Addons']&&MK['selfSwitchContainer']&&MK['rng']['_seedableRandomInteger']&&MK['generateSeed'];}function _0x5ea9e1(){return!Utils['isNwjs']()&&window['location']['hostname']=='play.aerosys.blog';}function _0x1dc690(){return Utils['isNwjs']()&&(Utils['isOptionValid']('test')||Utils['isOptionValid']('btest')||Utils['isOptionValid']('etest'));}const _0x5299f0=Scene_Boot['prototype']['start'];Scene_Boot['prototype']['start']=function(){_0x5299f0['call'](this),!_0x7e1b83()&&!_0x5ea9e1()&&(console['warn']('Using\x20free\x20trial\x20version\x20of\x20RNGMaps\x20-\x20Game\x20will\x20not\x20launch\x20when\x20exported.'),console['warn']('If\x20you\x20purchased\x20the\x20Full\x20Version,\x20please\x20add\x20MK_RNGMaps_Addons.js\x20to\x20unlock\x20this\x20Plugin.')),!_0x7e1b83()&&!_0x1dc690()&&!_0x5ea9e1()&&(alert('RNGMaps\x20(Free\x20Version)\x20only\x20usable\x20in\x20PLAYTEST\x0a\x0a'+'If\x20you\x20purchased\x20the\x20Full\x20Version,\x20please\x20add\x20MK_RNGMaps_Addons.js\x20to\x20unlock\x20this\x20Plugin.'),SceneManager['exit']()),_0x7e1b83()&&Imported['Drag_SandboxMap']&&!Drag['SandboxMap']['load']&&(alert('RNGMaps\x20(Full\x20Version)\x20and\x20Drag\x20Sandbox\x20(Demo\x20Version)\x20are\x20not\x20compatible!'),SceneManager['exit']());};}());class MK_PRNG{['randomInteger'](_0x4f0205,_0x155492){MK['requireNonNull'](_0x4f0205,'MK.rng.randomInteger','min'),MK['requireNonNull'](_0x155492,'MK.rng.randomInteger','max');if(_0x155492<_0x4f0205)return 0x0;return _0x4f0205==_0x155492?_0x4f0205:this['_randomInteger'](_0x4f0205,_0x155492);}['_randomInteger'](_0x448c9f,_0x4217f0){return this['_mathRandomMinMax'](_0x448c9f,_0x4217f0);}['_mathRandomMinMax'](_0x443e2c,_0x42de8e){return Math['floor'](Math['random']()*(_0x42de8e-_0x443e2c+0x1))+_0x443e2c;}['threshold'](_0x39ebb4){return MK['requireElseThrow'](0x0<=_0x39ebb4&&_0x39ebb4<=0x1,'Invalid\x20Argument:\x20'+_0x39ebb4),_0x39ebb4==0x1||_0x39ebb4*0x64>=this['randomInteger'](0x1,0x64);}['pickRandom'](_0x45bc11){return MK['requireNonEmpty'](_0x45bc11),_0x45bc11['length']==0x1?_0x45bc11[0x0]:_0x45bc11[MK['rng']['randomInteger'](0x0,_0x45bc11['length']-0x1)];}['setSeed'](){MK['onUsePremiumFunctionAlert']('setSeed');}['noSeedableRNG'](){MK['onUsePremiumFunctionAlert']('noSeedableRNG');}['hasSeed'](){return this['seed']!==undefined;}}MK['rng']=new MK_PRNG();class NoOptionsAvailableError extends Error{constructor(_0x39f147){super('Unable\x20to\x20find\x20spots\x20for\x20'+_0x39f147+'.\x20Try\x20to\x20make\x20it\x20easier\x20for\x20the\x20Plugin\x20to\x20find\x20spots.');}}MK['euclidianDistance']=function(_0x17c5e9,_0x36b3c3){return Math['sqrt'](Math['abs'](_0x36b3c3['x']-_0x17c5e9['x'])**0x2+Math['abs'](_0x36b3c3['y']-_0x17c5e9['y'])**0x2);},MK['manhattanDistance']=function(_0x3f5e71,_0x55cec6){return Math['abs'](_0x55cec6['x']-_0x3f5e71['x'])+Math['abs'](_0x55cec6['y']-_0x3f5e71['y']);},MK['kruskalMST']=function(_0x56f646,_0x5c50d8=MK['euclidianDistance']){if(_0x56f646['length']==0x1)return[];const _0x33c2ee=[],_0x55db97=[],_0x45b924=[];for(let _0x2b79cd=0x0;_0x2b79cd<_0x56f646['length'];_0x2b79cd++){for(let _0x2febb9=0x0;_0x2febb9<_0x56f646['length'];_0x2febb9++){if(_0x2b79cd==_0x2febb9)continue;_0x33c2ee['push']({'start':_0x56f646[_0x2b79cd],'dest':_0x56f646[_0x2febb9],'weight':_0x5c50d8['call'](this,_0x56f646[_0x2b79cd],_0x56f646[_0x2febb9])});}}_0x33c2ee['sort']((_0x5714b3,_0x398cfd)=>_0x5714b3['weight']-_0x398cfd['weight']);function _0x22a110(_0x1e4b7b){return _0x45b924['findIndex'](_0x335c1c=>_0x335c1c['contains'](_0x1e4b7b['start'])&&_0x335c1c['contains'](_0x1e4b7b['dest']))!=-0x1;}function _0x41e95b(_0x2c3fae){for(let _0x2641fd=0x0;_0x2641fd<_0x45b924['length'];_0x2641fd++){let _0x168487=_0x45b924[_0x2641fd];if(_0x168487['contains'](_0x2c3fae['start'])){_0x168487['push'](_0x2c3fae['dest']);for(let _0x1ac9f4=0x0;_0x1ac9f4<_0x45b924['length'];_0x1ac9f4++){if(_0x2641fd==_0x1ac9f4)continue;let _0x89ea37=_0x45b924[_0x1ac9f4];if(_0x89ea37['contains'](_0x2c3fae['dest'])){_0x89ea37['forEach'](_0x9165f=>_0x168487['push'](_0x9165f)),_0x45b924['splice'](_0x1ac9f4,0x1);return;}}return;}else{if(_0x168487['contains'](_0x2c3fae['dest'])){_0x168487['push'](_0x2c3fae['start']);for(let _0x3660dc=0x0;_0x3660dc<_0x45b924['length'];_0x3660dc++){if(_0x2641fd==_0x3660dc)continue;let _0x35edb4=_0x45b924[_0x3660dc];if(_0x35edb4['contains'](_0x2c3fae['start'])){_0x35edb4['forEach'](_0x3e1f2b=>_0x168487['push'](_0x3e1f2b)),_0x45b924['splice'](_0x3660dc,0x1);return;}}return;}}}_0x45b924['push']([_0x2c3fae['start'],_0x2c3fae['dest']]);}for(let _0x2bd602=0x0;_0x2bd602<_0x33c2ee['length'];_0x2bd602++){const _0xbb28b5=_0x33c2ee[_0x2bd602];!_0x22a110(_0xbb28b5)&&(_0x55db97['push'](_0xbb28b5),_0x41e95b(_0xbb28b5));if(_0x55db97['length']==_0x56f646['length']-0x1)break;}return _0x55db97;},MK['findAllByDirection']=function(_0x42c14e,_0x210a94,_0x1928c7,_0x3f27ac,_0x2604b5,_0x2acc9b,_0x5cc957=0x5,_0x2e1ce3=0x5){let _0x4e0e60=[],_0x18ba10,_0x3e693d,_0x11ed96,_0x2dc095;for(let _0x2f03e0=0x1;_0x4e0e60['length']==0x0;_0x2f03e0++){_0x2604b5=='top'&&(_0x18ba10=_0x42c14e,_0x3e693d=_0x210a94,_0x11ed96=(_0x2f03e0-0x1)*_0x2e1ce3+_0x1928c7,_0x2dc095=_0x2f03e0*_0x2e1ce3+_0x1928c7);_0x2604b5=='left'&&(_0x18ba10=(_0x2f03e0-0x1)*_0x5cc957+_0x42c14e,_0x3e693d=_0x2f03e0*_0x5cc957+_0x42c14e,_0x11ed96=_0x1928c7,_0x2dc095=_0x3f27ac);_0x2604b5=='right'&&(_0x18ba10=_0x210a94-_0x2f03e0*_0x5cc957,_0x3e693d=_0x210a94-(_0x2f03e0-0x1)*_0x5cc957,_0x11ed96=_0x1928c7,_0x2dc095=_0x3f27ac);_0x2604b5=='bottom'&&(_0x18ba10=_0x42c14e,_0x3e693d=_0x210a94,_0x11ed96=_0x3f27ac-_0x2f03e0*_0x2e1ce3,_0x2dc095=_0x3f27ac-(_0x2f03e0-0x1)*_0x2e1ce3);_0x2604b5=='any'&&(_0x18ba10=_0x42c14e,_0x3e693d=_0x210a94,_0x11ed96=_0x1928c7,_0x2dc095=_0x3f27ac);if(_0x18ba10<_0x42c14e||_0x3e693d>_0x210a94||_0x11ed96<_0x1928c7||_0x2dc095>_0x3f27ac)break;for(let _0x303abe=_0x18ba10;_0x303abe<_0x3e693d;_0x303abe++){for(let _0x5a0cb1=_0x11ed96;_0x5a0cb1<_0x2dc095;_0x5a0cb1++){_0x2acc9b['call'](this,_0x303abe,_0x5a0cb1)&&_0x4e0e60['push']({'x':_0x303abe,'y':_0x5a0cb1});}}if(_0x2604b5=='any')break;}return _0x4e0e60;},MK['mazeAlgorithms']={},MK['mazeAlgorithms']['prims']=function(_0x1554b9,_0x51438d){MK['requireNonNull'](_0x1554b9,'prims','w'),MK['requireNonNull'](_0x51438d,'prims','h');const _0x36b81b=MK['createMatrix'](_0x1554b9,_0x51438d),_0x5357b5=[];for(let _0x1fe3f5=0x0;_0x1fe3f5<_0x1554b9;_0x1fe3f5++){for(let _0x3bec44=0x0;_0x3bec44<_0x51438d;_0x3bec44++){_0x5357b5['push']({'x':_0x1fe3f5,'y':_0x3bec44});}}_0x36b81b[0x1][0x0]=_0x36b81b[0x1][0x0]|0x4,_0x36b81b[0x1][0x1]=_0x36b81b[0x1][0x1]|0x1;let _0x2c89dc=_0x1554b9*_0x51438d;while(_0x2c89dc>0x0){_0x2c89dc-=0x1;let _0x1db506=[];for(let _0x2fec30=0x0;_0x2fec30<_0x5357b5['length'];_0x2fec30++){let _0x5f2742=_0x5357b5[_0x2fec30];if(_0x36b81b[_0x5f2742['x']][_0x5f2742['y']]==0x0&&_0x5f2742['x']!=0x0&&_0x36b81b[_0x5f2742['x']-0x1][_0x5f2742['y']]!=0x0)_0x1db506['push'](_0x5f2742);if(_0x36b81b[_0x5f2742['x']][_0x5f2742['y']]==0x0&&_0x5f2742['x']<_0x1554b9-0x1&&_0x36b81b[_0x5f2742['x']+0x1][_0x5f2742['y']]!=0x0)_0x1db506['push'](_0x5f2742);if(_0x36b81b[_0x5f2742['x']][_0x5f2742['y']]==0x0&&_0x5f2742['y']!=0x0&&_0x36b81b[_0x5f2742['x']][_0x5f2742['y']-0x1]!=0x0)_0x1db506['push'](_0x5f2742);if(_0x36b81b[_0x5f2742['x']][_0x5f2742['y']]==0x0&&_0x5f2742['y']<_0x51438d-0x1&&_0x36b81b[_0x5f2742['x']][_0x5f2742['y']+0x1]!=0x0)_0x1db506['push'](_0x5f2742);}if(_0x1db506['length']==0x0)break;let _0x4e8df8=MK['rng']['pickRandom'](_0x1db506),_0x3875d4=[];if(_0x4e8df8['x']>0x0&&_0x36b81b[_0x4e8df8['x']-0x1][_0x4e8df8['y']]!=0x0)_0x3875d4['push']('left');if(_0x4e8df8['x']<_0x1554b9-0x1&&_0x36b81b[_0x4e8df8['x']+0x1][_0x4e8df8['y']]!=0x0)_0x3875d4['push']('right');if(_0x4e8df8['y']>0x0&&_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']-0x1]!=0x0)_0x3875d4['push']('up');if(_0x4e8df8['y']<_0x51438d-0x1&&_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']+0x1]!=0x0)_0x3875d4['push']('down');let _0x2a7696=MK['rng']['pickRandom'](_0x3875d4);_0x2a7696=='left'&&(_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']]=_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']]|0x8,_0x36b81b[_0x4e8df8['x']-0x1][_0x4e8df8['y']]=_0x36b81b[_0x4e8df8['x']-0x1][_0x4e8df8['y']]|0x2),_0x2a7696=='right'&&(_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']]=_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']]|0x2,_0x36b81b[_0x4e8df8['x']+0x1][_0x4e8df8['y']]=_0x36b81b[_0x4e8df8['x']+0x1][_0x4e8df8['y']]|0x8),_0x2a7696=='up'&&(_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']]=_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']]|0x1,_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']-0x1]=_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']-0x1]|0x4),_0x2a7696=='down'&&(_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']]=_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']]|0x4,_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']+0x1]=_0x36b81b[_0x4e8df8['x']][_0x4e8df8['y']+0x1]|0x1);}return _0x36b81b;},MK['mazeAlgorithms']['cutOffDeadEnds']=function(_0x15e69e,_0x196d34=0x1){MK['requireNonNull'](_0x15e69e,'cutOffDeadEnds','map');for(let _0x103fa0=0x0;_0x103fa0<_0x196d34;_0x103fa0++){let _0x3c6fed=[];for(let _0x20bdc1=0x0;_0x20bdc1<_0x15e69e['length'];_0x20bdc1++){for(let _0x4bd8de=0x0;_0x4bd8de<_0x15e69e[_0x20bdc1]['length'];_0x4bd8de++){if([0x1,0x2,0x4,0x8]['contains'](_0x15e69e[_0x20bdc1][_0x4bd8de]))_0x3c6fed['push']({'x':_0x20bdc1,'y':_0x4bd8de});}}for(let _0x5b04cb of _0x3c6fed){let _0x30510d=_0x5b04cb['x'],_0x4b40e7=_0x5b04cb['y'];_0x15e69e[_0x30510d][_0x4b40e7]==0x1&&(_0x15e69e[_0x30510d][_0x4b40e7]=0x0,_0x15e69e[_0x30510d][_0x4b40e7-0x1]=_0x15e69e[_0x30510d][_0x4b40e7-0x1]&0xb),_0x15e69e[_0x30510d][_0x4b40e7]==0x2&&(_0x15e69e[_0x30510d][_0x4b40e7]=0x0,_0x15e69e[_0x30510d+0x1][_0x4b40e7]=_0x15e69e[_0x30510d+0x1][_0x4b40e7]&0x7),_0x15e69e[_0x30510d][_0x4b40e7]==0x4&&(_0x15e69e[_0x30510d][_0x4b40e7]=0x0,_0x15e69e[_0x30510d][_0x4b40e7+0x1]=_0x15e69e[_0x30510d][_0x4b40e7+0x1]&0xe),_0x15e69e[_0x30510d][_0x4b40e7]==0x8&&(_0x15e69e[_0x30510d][_0x4b40e7]=0x0,_0x15e69e[_0x30510d-0x1][_0x4b40e7]=_0x15e69e[_0x30510d-0x1][_0x4b40e7]&0xd);}}},MK['mazeAlgorithms']['mergeDeadEnds']=function(_0x58cbef,_0x2d7475=0.3){MK['requireNonNull'](_0x58cbef,'mergeDeadEnds','map');for(let _0x5a9434=0x0;_0x5a9434<_0x58cbef['length'];_0x5a9434++){for(let _0x24f695=0x0;_0x24f695<_0x58cbef[_0x5a9434]['length'];_0x24f695++){if([0x1,0x2,0x4,0x8]['contains'](_0x58cbef[_0x5a9434][_0x24f695])){if(!MK['rng']['threshold'](_0x2d7475))continue;let _0xa0c581=[];if(_0x58cbef[_0x5a9434][_0x24f695]!=0x1&&_0x24f695>0x0&&_0x58cbef[_0x5a9434][_0x24f695-0x1]!=0x0)_0xa0c581['push']('up');if(_0x58cbef[_0x5a9434][_0x24f695]!=0x2&&_0x5a9434<_0x58cbef['length']-0x1&&_0x58cbef[_0x5a9434+0x1][_0x24f695]!=0x0)_0xa0c581['push']('right');if(_0x58cbef[_0x5a9434][_0x24f695]!=0x4&&_0x24f695<_0x58cbef[_0x5a9434]['length']-0x1&&_0x58cbef[_0x5a9434][_0x24f695+0x1]!=0x0)_0xa0c581['push']('down');if(_0x58cbef[_0x5a9434][_0x24f695]!=0x8&&_0x5a9434>0x0&&_0x58cbef[_0x5a9434-0x1][_0x24f695]!=0x0)_0xa0c581['push']('left');if(_0xa0c581['length']==0x0)continue;const _0x1224c5=MK['rng']['pickRandom'](_0xa0c581);_0x1224c5=='up'&&(_0x58cbef[_0x5a9434][_0x24f695]=_0x58cbef[_0x5a9434][_0x24f695]|0x1,_0x58cbef[_0x5a9434][_0x24f695-0x1]=_0x58cbef[_0x5a9434][_0x24f695-0x1]|0x4),_0x1224c5=='right'&&(_0x58cbef[_0x5a9434][_0x24f695]=_0x58cbef[_0x5a9434][_0x24f695]|0x2,_0x58cbef[_0x5a9434+0x1][_0x24f695]=_0x58cbef[_0x5a9434+0x1][_0x24f695]|0x8),_0x1224c5=='down'&&(_0x58cbef[_0x5a9434][_0x24f695]=_0x58cbef[_0x5a9434][_0x24f695]|0x4,_0x58cbef[_0x5a9434][_0x24f695+0x1]=_0x58cbef[_0x5a9434][_0x24f695+0x1]|0x1),_0x1224c5=='left'&&(_0x58cbef[_0x5a9434][_0x24f695]=_0x58cbef[_0x5a9434][_0x24f695]|0x8,_0x58cbef[_0x5a9434-0x1][_0x24f695]=_0x58cbef[_0x5a9434-0x1][_0x24f695]|0x2);}}}},MK['mazeAlgorithms']['randomWalk']=function(_0x1c843c,_0x17ee82,_0x1ee553='bottom',_0x5d2e79='top',_0x390b0f=!![],_0x3b1df0=!![],_0x2b2f8e=![]){const _0x132606=['top','right','left','bottom'],_0x35522d=['top','right','left','bottom','any'];MK['requireNonNull'](_0x1c843c,'randomWalk','w'),MK['requireNonNull'](_0x17ee82,'randomWalk','h'),MK['requireToBeOneOfThese'](_0x1ee553,_0x35522d,'randomWalk','start'),MK['requireToBeOneOfThese'](_0x5d2e79,_0x35522d,'randomWalk','end'),_0x1ee553=_0x1ee553!='any'?_0x1ee553:MK['rng']['pickRandom'](_0x132606['filter'](_0x51e6e6=>_0x51e6e6!=_0x5d2e79)),_0x5d2e79=_0x5d2e79!='any'?_0x5d2e79:MK['rng']['pickRandom'](_0x132606['filter'](_0x54f0b2=>_0x54f0b2!=_0x1ee553));if(_0x1ee553==_0x5d2e79)throw Error('RandomWalk:\x20Cannot\x20start\x20and\x20end\x20from\x20same\x20direction');let _0x4d3fad=_0x390b0f||_0x1ee553!='top',_0x484f61=_0x390b0f||_0x1ee553!='right',_0x9a2c63=_0x390b0f||_0x1ee553!='left',_0x44534d=_0x390b0f||_0x1ee553!='bottom';const _0x6aef0a=MK['createMatrix'](_0x1c843c,_0x17ee82,0x0),_0x213c7e=MK['createMatrix'](_0x1c843c,_0x17ee82,![]);let _0x96eb8f,_0x51bcdd;_0x1ee553=='top'&&(_0x96eb8f=Math['floor'](_0x1c843c/0x2),_0x51bcdd=0x0);_0x1ee553=='right'&&(_0x96eb8f=_0x1c843c-0x1,_0x51bcdd=Math['floor'](_0x17ee82/0x2));_0x1ee553=='left'&&(_0x96eb8f=0x0,_0x51bcdd=Math['floor'](_0x17ee82/0x2));_0x1ee553=='bottom'&&(_0x96eb8f=Math['floor'](_0x1c843c/0x2),_0x51bcdd=_0x17ee82-0x1);_0x6aef0a[_0x96eb8f][_0x51bcdd]=0x1;var _0x4eca56=_0x96eb8f,_0x903294=_0x51bcdd,_0x282b13=[];_0x282b13['push']({'x':_0x4eca56,'y':_0x903294});while(_0x282b13['length']>0x0){_0x4eca56=_0x282b13[_0x282b13['length']-0x1]['x'],_0x903294=_0x282b13[_0x282b13['length']-0x1]['y'],_0x6aef0a[_0x4eca56][_0x903294]=0x1,_0x213c7e[_0x4eca56][_0x903294]=!![];var _0x131c87=[];if(_0x5d2e79=='top'&&_0x903294==0x0)break;if(_0x5d2e79=='right'&&_0x4eca56==_0x1c843c-0x1)break;if(_0x5d2e79=='left'&&_0x4eca56==0x0)break;if(_0x5d2e79=='bottom'&&_0x903294==_0x17ee82-0x1)break;function _0x265eff(_0x1aa081,_0xb6f1d8){return 0x0<=_0x1aa081&&_0x1aa081<_0x1c843c&&0x0<=_0xb6f1d8&&_0xb6f1d8<_0x17ee82;}function _0x2c58f1(_0x353674,_0x6b77ef){return _0x265eff(_0x353674,_0x6b77ef)&&(_0x2b2f8e||!_0x6aef0a[_0x353674][_0x6b77ef]&&!_0x213c7e[_0x353674][_0x6b77ef]);}function _0x132eca(_0x2f4a10,_0x126ea4){if(!_0x265eff(_0x2f4a10,_0x126ea4))return![];if(!_0x2b2f8e&&_0x213c7e[_0x2f4a10][_0x126ea4])return![];let _0x36c705=0x0;if(_0x265eff(_0x2f4a10,_0x126ea4-0x1)&&_0x6aef0a[_0x2f4a10][_0x126ea4-0x1])_0x36c705++;if(_0x265eff(_0x2f4a10,_0x126ea4+0x1)&&_0x6aef0a[_0x2f4a10][_0x126ea4+0x1])_0x36c705++;if(_0x265eff(_0x2f4a10-0x1,_0x126ea4)&&_0x6aef0a[_0x2f4a10-0x1][_0x126ea4])_0x36c705++;if(_0x265eff(_0x2f4a10+0x1,_0x126ea4)&&_0x6aef0a[_0x2f4a10+0x1][_0x126ea4])_0x36c705++;return _0x36c705<=0x1;}if(_0x3b1df0){if(_0x2c58f1(_0x4eca56,_0x903294-0x1)&&_0x4d3fad)_0x131c87['push']('up');if(_0x2c58f1(_0x4eca56+0x1,_0x903294)&&_0x484f61)_0x131c87['push']('right');if(_0x2c58f1(_0x4eca56-0x1,_0x903294)&&_0x9a2c63)_0x131c87['push']('left');if(_0x2c58f1(_0x4eca56,_0x903294+0x1)&&_0x44534d)_0x131c87['push']('down');}else{if(_0x132eca(_0x4eca56,_0x903294-0x1)&&_0x4d3fad)_0x131c87['push']('up');if(_0x132eca(_0x4eca56+0x1,_0x903294)&&_0x484f61)_0x131c87['push']('right');if(_0x132eca(_0x4eca56-0x1,_0x903294)&&_0x9a2c63)_0x131c87['push']('left');if(_0x132eca(_0x4eca56,_0x903294+0x1)&&_0x44534d)_0x131c87['push']('down');}if(_0x131c87['length']==0x0){_0x282b13['pop'](),_0x6aef0a[_0x4eca56][_0x903294]=0x0;continue;}const _0x3cb942=MK['rng']['pickRandom'](_0x131c87);if(_0x3cb942=='up')_0x903294=_0x903294-0x1;if(_0x3cb942=='right')_0x4eca56=_0x4eca56+0x1;if(_0x3cb942=='left')_0x4eca56=_0x4eca56-0x1;if(_0x3cb942=='down')_0x903294=_0x903294+0x1;_0x282b13['push']({'x':_0x4eca56,'y':_0x903294});}return this['binary2drawable'](_0x6aef0a);},MK['mazeAlgorithms']['binary2drawable']=function(_0x3eb7ca){const _0x5d1ccc=_0x3eb7ca['length'],_0x29cfb7=_0x3eb7ca[0x0]['length'],_0x4bc3bf=MK['createMatrix'](_0x5d1ccc,_0x29cfb7);function _0x38e599(_0x18c021,_0x4d5a2c){return _0x18c021>=0x0&&_0x18c021<_0x5d1ccc&&_0x4d5a2c>=0x0&&_0x4d5a2c<_0x29cfb7&&_0x3eb7ca[_0x18c021][_0x4d5a2c];}function _0x464bec(_0x338649,_0x2625e4){return _0x38e599(_0x338649-0x1,_0x2625e4)&&_0x38e599(_0x338649-0x1,_0x2625e4-0x1)&&_0x38e599(_0x338649,_0x2625e4-0x1)||_0x38e599(_0x338649,_0x2625e4-0x1)&&_0x38e599(_0x338649+0x1,_0x2625e4-0x1)&&_0x38e599(_0x338649+0x1,_0x2625e4)||_0x38e599(_0x338649+0x1,_0x2625e4)&&_0x38e599(_0x338649+0x1,_0x2625e4+0x1)&&_0x38e599(_0x338649,_0x2625e4+0x1)||_0x38e599(_0x338649,_0x2625e4+0x1)&&_0x38e599(_0x338649-0x1,_0x2625e4+0x1)&&_0x38e599(_0x338649-0x1,_0x2625e4);}for(let _0x243f1d=0x0;_0x243f1d<_0x5d1ccc;_0x243f1d++){for(let _0x35c55e=0x0;_0x35c55e<_0x29cfb7;_0x35c55e++){if(!_0x3eb7ca[_0x243f1d][_0x35c55e]){_0x4bc3bf[_0x243f1d][_0x35c55e]=0x0;continue;}let _0x386cf7=0x0;if(!_0x464bec(_0x243f1d,_0x35c55e)){if(_0x38e599(_0x243f1d,_0x35c55e-0x1))_0x386cf7=_0x386cf7|0x1;if(_0x38e599(_0x243f1d+0x1,_0x35c55e))_0x386cf7=_0x386cf7|0x2;if(_0x38e599(_0x243f1d,_0x35c55e+0x1))_0x386cf7=_0x386cf7|0x4;if(_0x38e599(_0x243f1d-0x1,_0x35c55e))_0x386cf7=_0x386cf7|0x8;}else{if(_0x38e599(_0x243f1d+0x1,_0x35c55e)&&_0x38e599(_0x243f1d+0x1,_0x35c55e+0x1)&&_0x38e599(_0x243f1d,_0x35c55e+0x1))_0x386cf7=_0x386cf7|0x1;if(_0x38e599(_0x243f1d-0x1,_0x35c55e)&&_0x38e599(_0x243f1d-0x1,_0x35c55e+0x1)&&_0x38e599(_0x243f1d,_0x35c55e+0x1))_0x386cf7=_0x386cf7|0x2;if(_0x38e599(_0x243f1d-0x1,_0x35c55e)&&_0x38e599(_0x243f1d-0x1,_0x35c55e-0x1)&&_0x38e599(_0x243f1d,_0x35c55e-0x1))_0x386cf7=_0x386cf7|0x4;if(_0x38e599(_0x243f1d,_0x35c55e-0x1)&&_0x38e599(_0x243f1d+0x1,_0x35c55e-0x1)&&_0x38e599(_0x243f1d+0x1,_0x35c55e))_0x386cf7=_0x386cf7|0x8;if(_0x386cf7==0x1)_0x386cf7=0x0;else{if(_0x386cf7==0x2)_0x386cf7=0x2;else{if(_0x386cf7==0x3)_0x386cf7=0x1;else{if(_0x386cf7==0x4)_0x386cf7=0x8;else{if(_0x386cf7==0x5)_0x386cf7=0xe;else{if(_0x386cf7==0x6)_0x386cf7=0x5;else{if(_0x386cf7==0x7)_0x386cf7=0xc;else{if(_0x386cf7==0x8)_0x386cf7=0x6;else{if(_0x386cf7==0x9)_0x386cf7=0x3;else{if(_0x386cf7==0xa)_0x386cf7=0xb;else{if(_0x386cf7==0xb)_0x386cf7=0xd;else{if(_0x386cf7==0xc)_0x386cf7=0x7;else{if(_0x386cf7==0xd)_0x386cf7=0xa;else{if(_0x386cf7==0xe)_0x386cf7=0x9;else{if(_0x386cf7==0xf)_0x386cf7=0x4;}}}}}}}}}}}}}}if(_0x386cf7==0x0&&_0x38e599(_0x243f1d,_0x35c55e-0x1)&&_0x38e599(_0x243f1d-0x1,_0x35c55e))_0x386cf7=0x10+0x3;else{if(_0x386cf7==0x2&&_0x38e599(_0x243f1d,_0x35c55e-0x1)&&_0x38e599(_0x243f1d+0x1,_0x35c55e))_0x386cf7=0x10+0x7;else{if(_0x386cf7==0x6&&_0x38e599(_0x243f1d,_0x35c55e+0x1)&&_0x38e599(_0x243f1d-0x1,_0x35c55e))_0x386cf7=0x10+0xf;else{if(_0x386cf7==0x8&&_0x38e599(_0x243f1d,_0x35c55e+0x1)&&_0x38e599(_0x243f1d+0x1,_0x35c55e))_0x386cf7=0x10+0xb;else{if(_0x386cf7==0x0&&_0x38e599(_0x243f1d,_0x35c55e-0x1))_0x386cf7=0x10+0x0;else{if(_0x386cf7==0x1&&_0x38e599(_0x243f1d,_0x35c55e-0x1))_0x386cf7=0x10+0x1;else{if(_0x386cf7==0x2&&_0x38e599(_0x243f1d,_0x35c55e-0x1))_0x386cf7=0x10+0x2;else{if(_0x386cf7==0x6&&_0x38e599(_0x243f1d,_0x35c55e+0x1))_0x386cf7=0x10+0x4;else{if(_0x386cf7==0x7&&_0x38e599(_0x243f1d,_0x35c55e+0x1))_0x386cf7=0x10+0x5;else{if(_0x386cf7==0x8&&_0x38e599(_0x243f1d,_0x35c55e+0x1))_0x386cf7=0x10+0x6;else{if(_0x386cf7==0x0&&_0x38e599(_0x243f1d-0x1,_0x35c55e))_0x386cf7=0x10+0x8;else{if(_0x386cf7==0x2&&_0x38e599(_0x243f1d+0x1,_0x35c55e))_0x386cf7=0x10+0x9;else{if(_0x386cf7==0x3&&_0x38e599(_0x243f1d-0x1,_0x35c55e))_0x386cf7=0x10+0xa;else{if(_0x386cf7==0x6&&_0x38e599(_0x243f1d-0x1,_0x35c55e))_0x386cf7=0x10+0xc;else{if(_0x386cf7==0x8&&_0x38e599(_0x243f1d+0x1,_0x35c55e))_0x386cf7=0x10+0xd;else{if(_0x386cf7==0x5&&_0x38e599(_0x243f1d+0x1,_0x35c55e))_0x386cf7=0x10+0xe;}}}}}}}}}}}}}}}_0x386cf7+=0x10;}_0x4bc3bf[_0x243f1d][_0x35c55e]=_0x386cf7;}}return _0x4bc3bf;},MK['mazeAlgorithms']['makeWayOut']=function(_0xb78820,_0x2a2364){MK['requireNonNull'](_0xb78820,'makeWayOut','map'),MK['requireToBeOneOfThese'](_0x2a2364,['top','left','right','bottom'],'makeWayOut','direction');const _0x2ce17f=[],_0x1075b4=_0xb78820['length'],_0x5cb865=_0xb78820[0x0]['length'];if(_0x2a2364=='bottom')for(let _0x8a9bd=0x0;_0x8a9bd<_0x1075b4;_0x8a9bd++){if(_0xb78820[_0x8a9bd][_0x5cb865-0x1]!=0x0)_0x2ce17f['push']({'x':_0x8a9bd,'y':_0x5cb865-0x1});}if(_0x2a2364=='right')for(let _0x2fb993=0x0;_0x2fb993<_0x5cb865;_0x2fb993++){if(_0xb78820[_0x1075b4-0x1][_0x2fb993]!=0x0)_0x2ce17f['push']({'x':_0x1075b4-0x1,'y':_0x2fb993});}if(_0x2a2364=='left')for(let _0x3e20d7=0x0;_0x3e20d7<_0x5cb865;_0x3e20d7++){if(_0xb78820[0x0][_0x3e20d7]!=0x0)_0x2ce17f['push']({'x':0x0,'y':_0x3e20d7});}if(_0x2a2364=='top')for(let _0x15e00d=0x0;_0x15e00d<_0x1075b4;_0x15e00d++){if(_0xb78820[_0x15e00d][0x0]!=0x0)_0x2ce17f['push']({'x':_0x15e00d,'y':0x0});}if(_0x2ce17f['length']>0x0){const _0x5ebf2f=MK['rng']['pickRandom'](_0x2ce17f);MK['mazeAlgorithms']['buildTunnel'](_0xb78820,_0x5ebf2f['x'],_0x5ebf2f['y'],_0x2a2364);}else MK['mazeAlgorithms']['connectMazeWithMapEnd'](_0xb78820,_0x2a2364);},MK['mazeAlgorithms']['connectMazeWithMapEnd']=function(_0x4b42d8,_0x469015){let _0x575667,_0xa5473b,_0x3716ee,_0x16457f,_0x4d704f;const _0x42386c=_0x4b42d8['length'],_0xab6280=_0x4b42d8[0x0]['length'];_0x469015=='top'&&(_0x575667=Math['floor'](_0x42386c/0x2),_0xa5473b=0x0,_0x3716ee=0x0,_0x16457f=0x1,_0x4d704f='bottom');_0x469015=='left'&&(_0x575667=0x0,_0xa5473b=Math['floor'](_0xab6280/0x2),_0x3716ee=0x1,_0x16457f=0x0,_0x4d704f='right');_0x469015=='right'&&(_0x575667=_0x42386c-0x1,_0xa5473b=Math['floor'](_0xab6280/0x2),_0x3716ee=-0x1,_0x16457f=0x0,_0x4d704f='left');_0x469015=='bottom'&&(_0x575667=Math['floor'](_0x42386c/0x2),_0xa5473b=_0xab6280-0x1,_0x3716ee=0x0,_0x16457f=-0x1,_0x4d704f='left');while(_0x4b42d8[_0x575667][_0xa5473b]==0x0){MK['mazeAlgorithms']['buildTunnel'](_0x4b42d8,_0x575667,_0xa5473b,_0x469015),MK['mazeAlgorithms']['buildTunnel'](_0x4b42d8,_0x575667,_0xa5473b,_0x4d704f),_0x575667=_0x575667+_0x3716ee,_0xa5473b=_0xa5473b+_0x16457f;}MK['mazeAlgorithms']['buildTunnel'](_0x4b42d8,_0x575667,_0xa5473b,_0x469015);},MK['mazeAlgorithms']['buildTunnel']=function(_0x35f1b7,_0x2ab835,_0x650047,_0x3ed08c){const _0x458013=_0x35f1b7[_0x2ab835][_0x650047];let _0x3e8144;if(_0x3ed08c=='top'&&_0x458013<0x10)_0x3e8144=_0x458013|0x1;if(_0x3ed08c=='right'&&_0x458013<0x10)_0x3e8144=_0x458013|0x2;if(_0x3ed08c=='bottom'&&_0x458013<0x10)_0x3e8144=_0x458013|0x4;if(_0x3ed08c=='left'&&_0x458013<0x10)_0x3e8144=_0x458013|0x8;if(_0x3ed08c=='top'&&_0x458013>=0x10){if(_0x458013==0x10+0x0)_0x3e8144=0x20+0x0;if(_0x458013==0x10+0x1)_0x3e8144=0x20+0x1;if(_0x458013==0x10+0x2)_0x3e8144=0x20+0x2;if(_0x458013==0x20+0x8)_0x3e8144=0x20+0x3;if(_0x458013==0x20+0x9)_0x3e8144=0x20+0x8;}if(_0x3ed08c=='right'&&_0x458013>=0x10){if(_0x458013==0x10+0x2)_0x3e8144=0x20+0x9;if(_0x458013==0x10+0x5)_0x3e8144=0x20+0xe;if(_0x458013==0x10+0x8)_0x3e8144=0x20+0xd;if(_0x458013==0x20+0x2)_0x3e8144=0x20+0x7;if(_0x458013==0x20+0x6)_0x3e8144=0x20+0xb;}if(_0x3ed08c=='bottom'&&_0x458013>=0x10){if(_0x458013==0x10+0x6)_0x3e8144=0x20+0x4;if(_0x458013==0x10+0x7)_0x3e8144=0x20+0x5;if(_0x458013==0x10+0x8)_0x3e8144=0x20+0x6;if(_0x458013==0x20+0xc)_0x3e8144=0x20+0xf;if(_0x458013==0x20+0xd)_0x3e8144=0x20+0xb;}if(_0x3ed08c=='left'&&_0x458013>=0x10){if(_0x458013==0x10+0x0)_0x3e8144=0x20+0x8;if(_0x458013==0x10+0x3)_0x3e8144=0x20+0xa;if(_0x458013==0x10+0x6)_0x3e8144=0x20+0xc;if(_0x458013==0x20+0x0)_0x3e8144=0x20+0x3;if(_0x458013==0x20+0x4)_0x3e8144=0x20+0xf;}_0x35f1b7[_0x2ab835][_0x650047]=_0x3e8144;},MK['mazeAlgorithms']['roomsAndCorridors']=function(_0x1dd058,_0x267815,_0x26d929,_0x485212,_0x20388d,_0x2db4af,_0x462682,_0x16b88d,_0x2978fd,_0x2d9443=0x0){let _0x36ad85=MK['rng']['randomInteger'](_0x26d929,_0x485212),_0x175966=MK['createMatrix'](_0x1dd058,_0x267815),_0x13232d=[],_0x2ebd3f=[];if(_0x1dd058-_0x2db4af-_0x2d9443<0x1||_0x267815-_0x16b88d-_0x2d9443<0x1)throw Error('Your\x20Space\x20Map\x20is\x20too\x20small\x20for\x20given\x20arguments.\x20'+'Please\x20increase\x20its\x20size\x20or\x20change\x20Map\x20generation\x20arguments');function _0x2fb2ac(_0xa1bb7c,_0x30540b){let _0x4db268=_0xa1bb7c['x']>_0x30540b['x']+_0x30540b['width']+0x1||_0x30540b['x']>_0xa1bb7c['x']+_0xa1bb7c['width']+0x1,_0x452062=_0xa1bb7c['y']>_0x30540b['y']+_0x30540b['height']+0x1||_0x30540b['y']>_0xa1bb7c['y']+_0xa1bb7c['height']+0x1;return!_0x4db268&&!_0x452062;}function _0x11640a(_0x10a280){return _0x2ebd3f['some'](_0xdf9bcc=>_0x2fb2ac(_0x10a280,_0xdf9bcc));}let _0x4b0b26=0x0;while(_0x2ebd3f['length']<_0x36ad85){let _0x3d3924=MK['rng']['randomInteger'](_0x20388d,_0x2db4af)-0x1,_0x25b698=MK['rng']['randomInteger'](_0x462682,_0x16b88d)-0x1,_0x53536a=MK['rng']['randomInteger'](_0x2d9443,_0x1dd058-_0x3d3924-0x1-_0x2d9443),_0x42583d=MK['rng']['randomInteger'](_0x2d9443,_0x267815-_0x25b698-0x1-_0x2d9443),_0x30ab62=new Rectangle(_0x53536a,_0x42583d,_0x3d3924,_0x25b698);!_0x2978fd&&_0x11640a(_0x30ab62)?_0x2ebd3f['shift']():_0x2ebd3f['push'](_0x30ab62);_0x4b0b26++;if(_0x4b0b26>=0x3e7)throw Error('Map\x20generation\x20failed.\x20Please\x20choose\x20other\x20arguments\x20or\x20make\x20the\x20Space\x20Map\x20larger');}for(let _0x28b509 of _0x2ebd3f){let _0x447288={};_0x447288['x']=Math['floor'](_0x28b509['width']/0x2)+_0x28b509['x'],_0x447288['y']=Math['floor'](_0x28b509['height']/0x2)+_0x28b509['y'],_0x13232d['push'](_0x447288);for(let _0x2d16f1=_0x28b509['x'];_0x2d16f1<=_0x28b509['x']+_0x28b509['width'];_0x2d16f1++){for(let _0x506761=_0x28b509['y'];_0x506761<=_0x28b509['y']+_0x28b509['height'];_0x506761++){_0x175966[_0x2d16f1][_0x506761]=!![];}}}const _0x7463f=MK['kruskalMST'](_0x13232d);for(let _0x5b2834 of _0x7463f){let _0x37b4d3=[],_0x308285=MK['rng']['threshold'](0.5),_0x5ce271=Math['min'](_0x5b2834['start']['x'],_0x5b2834['dest']['x']),_0xaf671d=Math['max'](_0x5b2834['start']['x'],_0x5b2834['dest']['x']),_0x353d05=_0x308285?_0x5b2834['start']['y']:_0x5b2834['dest']['y'],_0x4d056f=Math['min'](_0x5b2834['start']['y'],_0x5b2834['dest']['y']),_0x607d50=Math['max'](_0x5b2834['start']['y'],_0x5b2834['dest']['y']),_0x49a8ad=_0x308285?_0x5b2834['dest']['x']:_0x5b2834['start']['x'];for(let _0x3bf7aa=_0x5ce271;_0x3bf7aa<=_0xaf671d;_0x3bf7aa++){_0x37b4d3['push']({'x':_0x3bf7aa,'y':_0x353d05});}for(let _0x15a84e=_0x4d056f;_0x15a84e<=_0x607d50;_0x15a84e++){_0x37b4d3['push']({'x':_0x49a8ad,'y':_0x15a84e});}_0x37b4d3['forEach'](_0x5f1e47=>_0x175966[_0x5f1e47['x']][_0x5f1e47['y']]=!![]);}return MK['mazeAlgorithms']['binary2drawable'](_0x175966);};class AbstractMapGenerator{constructor(){this['spawnLocation']=null;}['reset'](){this['spawnLocation']=null,this['dataMap']=JsonEx['makeDeepCopy'](MK['getMapFromDisk']()),this['assetsInfo']={},this['shadows']=null;}['resetAfterFinalize'](){}['isValid'](_0x29cf4f,_0x5d3a2f){return 0x0<=_0x29cf4f&&_0x29cf4f<this['dataMap']['width']&&0x0<=_0x5d3a2f&&_0x5d3a2f<this['dataMap']['height'];}['setSeed'](_0x48b425){return MK['rng']['setSeed'](_0x48b425),this;}['noSeedableRNG'](){return MK['rng']['noSeedableRNG'](),this;}['drawAssetToXY'](_0x29db12,_0x3e8031,_0x599707,_0x46e11a,_0x1fc100){const _0x556750=_0x46e11a['w'],_0x5f3254=_0x46e11a['h'],_0x27358b=_0x1fc100*_0x556750+_0x46e11a['x'],_0x55ca04=_0x46e11a['y'],_0x531244=MK['getAdditionalMap'](_0x599707);MK['copyTiles'](_0x27358b,_0x55ca04,_0x556750,_0x5f3254,_0x29db12,_0x3e8031,_0x531244,this['dataMap']),MK['cloneEvents'](_0x27358b,_0x55ca04,_0x556750,_0x5f3254,_0x29db12,_0x3e8031,_0x531244,this['dataMap']);}['finalize'](){if(!this['spawnLocation'])this['spawnPlayerAt']();MK['eraseRegionIds'](this['dataMap'],[MK['EXIT_NORTH'],MK['MAIN_EXIT_NORTH'],MK['SPAWN_NORTH'],MK['EXIT_EAST'],MK['MAIN_EXIT_EAST'],MK['SPAWN_EAST'],MK['EXIT_SOUTH'],MK['MAIN_EXIT_SOUTH'],MK['SPAWN_SOUTH'],MK['EXIT_WEST'],MK['MAIN_EXIT_WEST'],MK['SPAWN_WEST']]),this['_putShadows'](),MK['injectDataMap'](this['dataMap'],this['spawnLocation']['x'],this['spawnLocation']['y']),this['resetAfterFinalize']();}['fixAutoTiles'](_0x4d5d89){MK['updateAllAutoTiles'](this['dataMap'],_0x4d5d89);}['setShadows'](_0x21def4,_0x375286,_0x4f0530){return this['shadows']={'horizontal':_0x21def4,'vertical1':_0x375286,'vertical2':_0x4f0530},this;}['_putShadows'](){const _0x9cef43=this['shadows']?this['shadows']['horizontal']:MK['shadows']['horizontal'],_0x547974=this['shadows']?this['shadows']['vertical1']:MK['shadows']['vertical1'],_0x5ea446=this['shadows']?this['shadows']['vertical2']:MK['shadows']['vertical2'];MK['automaticallyPutShadows'](this['dataMap'],_0x9cef43,_0x547974,_0x5ea446);}['setFloorId'](){MK['onUsePremiumFunctionAlert']('setFloorId');}['checkCondition'](_0x37cf21,_0x37f067){const _0x27b74a=!_0x37cf21['requireSwitch']||$gameSwitches['value'](_0x37cf21['switchId']),_0x2d1106=!_0x37f067||!_0x37cf21['requireExit']||'not\x20required'==_0x37cf21['requireExit']||'any\x20Exit\x20Top'==_0x37cf21['requireExit']&&_0x37f067['top']||'any\x20Exit\x20Left'==_0x37cf21['requireExit']&&_0x37f067['left']||'any\x20Exit\x20Right'==_0x37cf21['requireExit']&&_0x37f067['right']||'any\x20Exit\x20Bottom'==_0x37cf21['requireExit']&&_0x37f067['bottom'],_0x251667=!_0x37cf21['requireExit']||'not\x20required'==_0x37cf21['requireExit']||Imported['MK_RNGMaps_Metamaze']&&('any\x20Exit\x20Top'==_0x37cf21['requireExit']&&$metaMaze['hasExitTop']()||'any\x20Exit\x20Left'==_0x37cf21['requireExit']&&$metaMaze['hasExitLeft']()||'any\x20Exit\x20Right'==_0x37cf21['requireExit']&&$metaMaze['hasExitRight']()||'any\x20Exit\x20Bottom'==_0x37cf21['requireExit']&&$metaMaze['hasExitBottom']()||'Main\x20Exit\x20Top'==_0x37cf21['requireExit']&&$metaMaze['hasMainExitTop']()||'Main\x20Exit\x20Left'==_0x37cf21['requireExit']&&$metaMaze['hasMainExitLeft']()||'Main\x20Exit\x20Right'==_0x37cf21['requireExit']&&$metaMaze['hasMainExitRight']()||'Main\x20Exit\x20Bottom'==_0x37cf21['requireExit']&&$metaMaze['hasMainExitBottom']()||'Inner\x20Exit\x20Top'==_0x37cf21['requireExit']&&$metaMaze['hasInnerExitTop']()||'Inner\x20Exit\x20Left'==_0x37cf21['requireExit']&&$metaMaze['hasInnerExitLeft']()||'Inner\x20Exit\x20Right'==_0x37cf21['requireExit']&&$metaMaze['hasInnerExitRight']()||'Inner\x20Exit\x20Bottom'==_0x37cf21['requireExit']&&$metaMaze['hasInnerExitBottom']());return _0x27b74a&&(_0x2d1106||_0x251667);}}